
#import "MBEMetalContext.h"

@implementation MBEMetalContext

+ (instancetype)defaultContext {
    static dispatch_once_t onceToken;
    static MBEMetalContext *instance = nil;
    dispatch_once(&onceToken, ^{
        id<MTLDevice> device = MTLCreateSystemDefaultDevice();
        instance = [[MBEMetalContext alloc] initWithDevice:device];
    });

    return instance;
}

- (instancetype)initWithDevice:(id<MTLDevice>)device {
    if ((self = [super init])) {
        _device = device;
        _library = [_device newDefaultLibrary];
        _commandQueue = [_device newCommandQueue];
    }

    return self;
}

@end
